import { 
  select,
  csv,
  scaleLinear,
  max,
  scaleBand,
  axisLeft,
	axisBottom} 
from 'd3';



const svg = select('svg');

const width = +svg.attr('width');
const height = +svg.attr('height');

const render = data => {
  const margin = {
    top: 20,
    right: 40,
    bottom: 50,
    left: 50
  };
  const innerWidth = width - margin.left - margin.right;
  const innerHeight = height - margin.top - margin.bottom;
  
  
  
  
  
  
  const name = data.map(d => d.name);
  console.log(name);
  const splitName = getSplit(name);
  
  function getSplit(array){
		const output = [];
		 for(let i = 0; i < array.length; i++){
			output[i] = array[i].split(' ');   
   	 }
		return output     
  	}
  console.log(splitName);
  
  
  const mergedName = [].concat.apply([], splitName);
  console.log(mergedName);

  const countTerm = getCount(mergedName);
  
  function getCount(array) {
      var a = [], b = [], prev;

      array.sort();
      for ( var i = 0; i < array.length; i++ ) {
          if ( array[i] !== prev ) {
              a.push(array[i]);
              b.push(1);
          } else {
              b[b.length-1]++;
          }
          prev = array[i];
      }   
      return [a, b];
  }

  var result = getCount(mergedName);
  
  console.log(result);
  const terms = result[0];
  const termsValue = result[1];
  console.log(terms);
	console.log(termsValue);
  

	const correctTerm = terms.map(function(d, i){
  	return{
    	term: d,
      count: termsValue[i]  
    };
  })
 
  correctTerm.sort(function (a, b) {
  return b.count - a.count;
	});
  console.log(correctTerm);
  

  console.log(correctTerm.slice(0, 3));
  
  
  
  

  
  
  
  const born =  data.map(d => d.date_incorp); 
  console.log(born);
  const bornYear = getYear(born);
  console.log(bornYear);
  
  
  const death =  data.map(d => d.date_dissov); 
  const deathYear = getYear(death);
  console.log(deathYear);
  
  function getYear(array){
    const output = [];
  	for(let element of array){
    	output.push(element.getFullYear());
    }
    return output;
  }
  
  const ages  = getAge(bornYear, deathYear);
  function getAge(array1, array2){
  	const output = [];
    for(let i = 0; i < array1.length; i++){
    	output.push(array2[i] - array1[i]);
    }
    return output;
  }
  console.log(ages);

	const ageGroups = ['0-3', '4-7', '8-11', '12-15', 'More than 15'];
  
  const count = countLength(ages);
  function countLength(array){
  	const output = [0, 0, 0, 0, 0];
    for(let i = 0; i < array.length; i++){
    	if(array[i] <= 3){
      	output[0] += 1;
      }
      else if(array[i] >= 4 && array[i] <= 7){
        output[1] += 1;                    
    	}
      else if(array[i] >= 8 && array[i] <= 11){
        output[2] += 1;  
      }
      else if(array[i] >= 12 && array[i] <= 15){
        output[3] += 1;  
      }
      else
        output[4] += 1;      
  	}
  	return output;
  }
  
  console.log(count);

	
  
  const correctData = ageGroups.map(function(d, i){
  	return{
    	group: d,
      value: count[i]  
    };
  })
  console.log(correctData);
  
  
  
  const xScale = d3.scaleBand()
  	.range([0, innerWidth])
  	.domain(correctData.map(d => d.group))
  	.padding(0.1);
    
  
  const yScale = d3.scaleLinear()
    .range([innerHeight, 0])
    .domain([0, d3.max(correctData, d => d.value)]);
  
  const g = svg.append('g')
    .attr('transform', `translate(${margin.left},${margin.top})`);

  g.append('g').call(d3.axisLeft(yScale));
  g.append('g').call(d3.axisBottom(xScale))
    .attr('transform', `translate(0,${innerHeight})`);
  
  g.selectAll()
    .data(correctData)
    .enter()
    .append('rect')  	
  	.attr('x', d => xScale(d.group))
    .attr('y', d => yScale(d.value))
 	 	.attr('height', d => innerHeight - yScale(d.value))
  	.attr('width', xScale.bandwidth());

  
};

csv('data.csv').then(data => {
  data.forEach(d => {
      d.date_incorp = new Date(d.date_incorp);
    	d.date_dissov = new Date(d.date_dissov);
    });
	render(data);   
});











